/* $Workfile: OsaImplementation.cpp $   $Revision: 5 $    $Modtime: 11/06/03 3:54p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 1998-2003, All Rights Reserved

*******************************************************************************/

#include "Osa.h"
#include "OsaImplementation.h"

OsaDriverEntryPointsS  g_sOsaDriverEntryPoints; 
OsaPlatformE gOsaPlatform = OSA_PLATFORM_UNDEFINED;

/******************************************************************************
******************************************************************************/
void OsaInit()
{
  // Set all pointers to NULL (assuming NULL is 0x00)
  memset(&g_sOsaDriverEntryPoints, 0x00, sizeof(OsaDriverEntryPointsS)); 
};


/******************************************************************************
******************************************************************************/
bool OsaCheckCallbacks()
{
  if (
    !g_sOsaDriverEntryPoints.pfnUnload          ||     
    !g_sOsaDriverEntryPoints.pfnAddBoard        ||      
    !g_sOsaDriverEntryPoints.pfnStartBoard      ||    
    !g_sOsaDriverEntryPoints.pfnBoardState      ||    
    !g_sOsaDriverEntryPoints.pfnRemoveBoard     ||   
    !g_sOsaDriverEntryPoints.pfnOpenDevice      ||    
    !g_sOsaDriverEntryPoints.pfnCloseDevice     ||   
    !g_sOsaDriverEntryPoints.pfnIoControlDevice
    )
  {
    return false;
  } else {
    return true;
  }
}

/******************************************************************************
******************************************************************************/
void OsaSetUnloadCallback(OsaUnloadFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnUnload = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetAddBoardCallback(OsaAddBoardFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnAddBoard = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetStartBoardCallback(OsaStartBoardFnP pfnCallback)             
{
  g_sOsaDriverEntryPoints.pfnStartBoard = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetBoardStateCallback(OsaBoardStateFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnBoardState = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetRemoveBoardCallback(OsaRemoveBoardFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnRemoveBoard = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetOpenDeviceCallback(OsaOpenDeviceFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnOpenDevice = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetCloseDeviceCallback(OsaCloseDeviceFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnCloseDevice = pfnCallback;
}


/******************************************************************************
******************************************************************************/
void OsaSetIoControlDeviceCallback(OsaIoControlDeviceFnP pfnCallback)
{
  g_sOsaDriverEntryPoints.pfnIoControlDevice = pfnCallback;
}


/******************************************************************************
  See also struct OsaTransStruct and macro OSA_MK_TRANS_STRUCT()
******************************************************************************/
const char *OsaFindTextForCode(OsaTransStruct sqTextCodeMappings[], OsaUint32 nCode) 
{
  OsaTransStruct *pTransStruct = sqTextCodeMappings;
  while (pTransStruct->pszText) {
    if (pTransStruct->nCode == nCode) {
      return pTransStruct->pszText;
    }
    pTransStruct++;
  }
  return "??";
}


/******************************************************************************
******************************************************************************/
const OsaString &OsaGetExternalDeviceName(OsaExternalDeviceRep externalDeviceRep)
{
  OsaDevice *pExternalDevice = reinterpret_cast<OsaDevice *>(externalDeviceRep);
  return pExternalDevice->m_strName;
}


/******************************************************************************
******************************************************************************/
OsaUint32 OsaGetHwLocationAddress(IN OsaExternalDeviceRep externalDeviceRep)
{
  OsaDevice *pExternalDevice = reinterpret_cast<OsaDevice *>(externalDeviceRep);

  OSA_ASSERT(pExternalDevice);

  return pExternalDevice->m_nHwLocationAddress;
}

/******************************************************************************
******************************************************************************/
OsaInt32 OsaGetPcmciaSocketNumber(IN OsaExternalDeviceRep externalDeviceRep)
{
  OsaDevice *pExternalDevice = reinterpret_cast<OsaDevice *>(externalDeviceRep);

  OSA_ASSERT(pExternalDevice);

  return pExternalDevice->m_nPcmciaSocketNumber;
}

/******************************************************************************
******************************************************************************/
OsaInt32 OsaGetPcmciaControllerNumber(IN OsaExternalDeviceRep externalDeviceRep)
{
  OsaDevice *pExternalDevice = reinterpret_cast<OsaDevice *>(externalDeviceRep);

  OSA_ASSERT(pExternalDevice);

  return pExternalDevice->m_nPcmciaControllerNumber;
}
